using System;
using System.Collections.Generic;
using System.Text;

using System.Net.Sockets;


namespace WindowsApplication1
{
    class CCDDB
    {
        private NetworkStream freedbstream;
        private TcpClient freedb;
        public void connect()
        {
            freedb= new TcpClient("freedb.freedb.org", 8880);
            Console.WriteLine( freedb.Connected);

            freedbstream = freedb.GetStream();
            
            
            Console.WriteLine(receive());
            //EDIT THE FOLLOWING LINES TO 
            //USERNAME DOMAIN PROGID VERSION
            //AS DESCRIBED IN THE ARTICLE
  
            send("cddb hello USERNAME WWW.DOMAIN.COM PROGID 1");
            Console.WriteLine(receive());

            CCDAudio CDAudio = new CCDAudio();
            string diskdata=CDAudio.getDiscData();
            
            send("discid " + diskdata);
            string response=receive();
            Console.WriteLine(response);

            string[] temp=response.Split(' ');
            String DiscId=temp[4];
            Console.WriteLine(DiscId);
        

            send("cddb query " + DiscId + " " + diskdata);
            response = receive();
            Console.WriteLine(response);
            temp = response.Split(' ');
            String categ = temp[1];
            
            send("cddb read " +categ  + " " +DiscId );
            Console.WriteLine(receive());
            Console.WriteLine(receive());

            send("quit");
            Console.WriteLine(receive());
            
            freedb.Close();
            Console.WriteLine();
            
        }

        private void send(string message)
        {
            byte[] buff = Encoding.ASCII.GetBytes(message+"\n");
            Console.WriteLine(message + "\n");
            freedbstream.Write(buff, 0, buff.GetLength(0));
        }
        private string receive()
        {
            byte[] buff = new byte[2000];
            freedbstream.Read(buff, 0, buff.GetLength(0));
            string temp=Encoding.ASCII.GetString(buff);
            char[] trail={'\n','\0','\r'};
            return temp.TrimEnd(trail);
        }
    }
}
